"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _types = require("./types");

var _state = require("./state");

var _utils = require("./utils");

var Symbol = global['jest-symbol-do-not-touch'] || global.Symbol;
var Symbol = global['jest-symbol-do-not-touch'] || global.Symbol;
var Promise = global[Symbol.for('jest-native-promise')] || global.Promise;

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

const run = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator(function* () {
    const _getState = (0, _state.getState)(),
          rootDescribeBlock = _getState.rootDescribeBlock;

    (0, _state.dispatch)({
      name: 'run_start'
    });
    yield _runTestsForDescribeBlock(rootDescribeBlock);
    (0, _state.dispatch)({
      name: 'run_finish'
    });
    return (0, _utils.makeRunResult)((0, _state.getState)().rootDescribeBlock, (0, _state.getState)().unhandledErrors);
  });

  return function run() {
    return _ref.apply(this, arguments);
  };
}();

const _runTestsForDescribeBlock = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator(function* (describeBlock) {
    (0, _state.dispatch)({
      describeBlock,
      name: 'run_describe_start'
    });

    const _getAllHooksForDescri = (0, _utils.getAllHooksForDescribe)(describeBlock),
          beforeAll = _getAllHooksForDescri.beforeAll,
          afterAll = _getAllHooksForDescri.afterAll;

    var _iterator = _createForOfIteratorHelper(beforeAll),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        const hook = _step.value;
        yield _callCircusHook({
          describeBlock,
          hook
        });
      } // Tests that fail and are retried we run after other tests

    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }

    const retryTimes = parseInt(global[_types.RETRY_TIMES], 10) || 0;
    const deferredRetryTests = [];

    var _iterator2 = _createForOfIteratorHelper(describeBlock.tests),
        _step2;

    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        const test = _step2.value;
        const hasErrorsBeforeTestRun = test.errors.length > 0;
        yield _runTest(test);

        if (hasErrorsBeforeTestRun === false && retryTimes > 0 && test.errors.length > 0) {
          deferredRetryTests.push(test);
        }
      } // Re-run failed tests n-times if configured

    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }

    for (var _i = 0, _deferredRetryTests = deferredRetryTests; _i < _deferredRetryTests.length; _i++) {
      const test = _deferredRetryTests[_i];
      let numRetriesAvailable = retryTimes;

      while (numRetriesAvailable > 0 && test.errors.length > 0) {
        // Clear errors so retries occur
        (0, _state.dispatch)({
          name: 'test_retry',
          test
        });
        yield _runTest(test);
        numRetriesAvailable--;
      }
    }

    var _iterator3 = _createForOfIteratorHelper(describeBlock.children),
        _step3;

    try {
      for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
        const child = _step3.value;
        yield _runTestsForDescribeBlock(child);
      }
    } catch (err) {
      _iterator3.e(err);
    } finally {
      _iterator3.f();
    }

    var _iterator4 = _createForOfIteratorHelper(afterAll),
        _step4;

    try {
      for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
        const hook = _step4.value;
        yield _callCircusHook({
          describeBlock,
          hook
        });
      }
    } catch (err) {
      _iterator4.e(err);
    } finally {
      _iterator4.f();
    }

    (0, _state.dispatch)({
      describeBlock,
      name: 'run_describe_finish'
    });
  });

  return function _runTestsForDescribeBlock(_x) {
    return _ref2.apply(this, arguments);
  };
}();

const _runTest = /*#__PURE__*/function () {
  var _ref3 = _asyncToGenerator(function* (test) {
    (0, _state.dispatch)({
      name: 'test_start',
      test
    });
    const testContext = Object.create(null);

    const _getState2 = (0, _state.getState)(),
          hasFocusedTests = _getState2.hasFocusedTests,
          testNamePattern = _getState2.testNamePattern;

    const isSkipped = test.mode === 'skip' || hasFocusedTests && test.mode !== 'only' || testNamePattern && !testNamePattern.test((0, _utils.getTestID)(test));

    if (isSkipped) {
      (0, _state.dispatch)({
        name: 'test_skip',
        test
      });
      return;
    }

    if (test.mode === 'todo') {
      (0, _state.dispatch)({
        name: 'test_todo',
        test
      });
      return;
    }

    const _getEachHooksForTest = (0, _utils.getEachHooksForTest)(test),
          afterEach = _getEachHooksForTest.afterEach,
          beforeEach = _getEachHooksForTest.beforeEach;

    var _iterator5 = _createForOfIteratorHelper(beforeEach),
        _step5;

    try {
      for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
        const hook = _step5.value;

        if (test.errors.length) {
          // If any of the before hooks failed already, we don't run any
          // hooks after that.
          break;
        }

        yield _callCircusHook({
          hook,
          test,
          testContext
        });
      }
    } catch (err) {
      _iterator5.e(err);
    } finally {
      _iterator5.f();
    }

    yield _callCircusTest(test, testContext);

    var _iterator6 = _createForOfIteratorHelper(afterEach),
        _step6;

    try {
      for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
        const hook = _step6.value;
        yield _callCircusHook({
          hook,
          test,
          testContext
        });
      } // `afterAll` hooks should not affect test status (pass or fail), because if
      // we had a global `afterAll` hook it would block all existing tests until
      // this hook is executed. So we dispatch `test_done` right away.

    } catch (err) {
      _iterator6.e(err);
    } finally {
      _iterator6.f();
    }

    (0, _state.dispatch)({
      name: 'test_done',
      test
    });
  });

  return function _runTest(_x2) {
    return _ref3.apply(this, arguments);
  };
}();

const _callCircusHook = ({
  hook,
  test,
  describeBlock,
  testContext
}) => {
  (0, _state.dispatch)({
    hook,
    name: 'hook_start'
  });
  const timeout = hook.timeout || (0, _state.getState)().testTimeout;
  return (0, _utils.callAsyncCircusFn)(hook.fn, testContext, {
    isHook: true,
    timeout
  }).then(() => (0, _state.dispatch)({
    describeBlock,
    hook,
    name: 'hook_success',
    test
  })).catch(error => (0, _state.dispatch)({
    describeBlock,
    error,
    hook,
    name: 'hook_failure',
    test
  }));
};

const _callCircusTest = (test, testContext) => {
  (0, _state.dispatch)({
    name: 'test_fn_start',
    test
  });
  const timeout = test.timeout || (0, _state.getState)().testTimeout;
  (0, _utils.invariant)(test.fn, `Tests with no 'fn' should have 'mode' set to 'skipped'`);

  if (test.errors.length) {
    // We don't run the test if there's already an error in before hooks.
    return Promise.resolve();
  }

  return (0, _utils.callAsyncCircusFn)(test.fn, testContext, {
    isHook: false,
    timeout
  }).then(() => (0, _state.dispatch)({
    name: 'test_fn_success',
    test
  })).catch(error => (0, _state.dispatch)({
    error,
    name: 'test_fn_failure',
    test
  }));
};

var _default = run;
exports.default = _default;